#ifndef _GRAPH
#define _GRAPH

#include <iostream>

#include "Game.H"
#include "intersect.H"
#include "TerrainBase.H"
#include "Sheep.H"


#include <map>
#include <queue>
#include <set>
#include <list>

#define FOREACH(it,x) for (__typeof((x).begin()) it=((x).begin()); it!=(x).end();++it)

using namespace std;
typedef TerrainBase::Loc Loc;
typedef TerrainBase::Segment line_seg;
typedef pair<Loc, sint4> thick_point;
class GameObj;
class Worker;


inline sint4 distance2(Loc a, Loc b){return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);}
struct p_vert {
	int v;
	double d;
	p_vert(int _v, double _d):v(_v),d(_d){}
};
inline bool operator < (const p_vert b,const p_vert a){
	return b.d>a.d;
}


#define MAX_VERT 100000
class Graph { public:
	
	map<Loc,int> coord2v;
	map<int,Loc> v2coord;

	int num_v;

	list<int> g[MAX_VERT];
	int k,l;

	int getVertex(Loc);
	int closest(Loc p);
	int closestFree(Loc p);
	list<line_seg> bound;
	list<thick_point> res;
	double v_dist(int u, int v);
	
	// zarzyk usun to jak bedziesz pisal to w wakacje
	GameObj* findClosest(GameObj& obj1);


	list<Loc>& shortestPath(Loc p1, Loc p2);
	list<Loc>& shortestPath(Loc, std::set<Loc>&);

	bool testpath(line_seg a, sint4 d);
	
					//d1 - max distance between vertices, d2 - min distance from obstacles
	Graph(const Game &game, int _k, int _l, int d1, int  d2,
			list<line_seg> &bound, list<thick_point>& res);
};


#endif
