#ifndef SampleEventHandler_H
#define SampleEventHandler_H

// $Id: SampleEventHandler.H,v 1.1 2005/10/19 21:25:38 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "EventHandler.H"
#include "Random.H"

class GameStateModule;
class GfxModule;
class GameChanges;
class Graph;
class AIState;

// This class gives the event handler access to all game and gfx data

// This class handles server events
// In particular it generates game object actions

class SampleEventHandler : public EventHandler {

public:
  
  AIState &state;

  SampleEventHandler(AIState &state_, sint4 seed) : state(state_) {
    rand.srand(seed);
  }

  bool handle_event(const Event &e);

private:
  
  void compute_actions();
  Graph& constructGraph(const GameChanges&);
  Random rand; // local RNG
  
};

#endif
