#include <iostream>
#include <algorithm>
#include <cmath>
#include "intersect.H"
using namespace std;

#define N 1000000.0

double iloczyn(pun p1, pun p2, pun p3){
	return (p1.x-p2.x)*(p3.y-p2.y)-(p3.x-p2.x)*(p1.y-p2.y);
}

double sgn(double a){
	if (a<0) return -1;
	if (a>0) return 1;
	return 0;
}

bool away(pun& p1, pun& p2, pun& p3, pun& p4){
	return (p1.x > p3.x && p1.x > p4.x && p2.x > p3.x && p2.x > p4.x) ||
		(p1.x < p3.x && p1.x < p4.x && p2.x < p3.x && p2.x < p4.x) ||
		(p1.y > p3.y && p1.y > p4.y && p2.y > p3.y && p2.y > p4.y) ||
		(p1.y < p3.y && p1.y < p4.y && p2.y < p3.y && p2.y < p4.y);


}

bool intersect(pun& p1, pun& p2, pun& p3, pun& p4){
	if (away(p1,p2,p3,p4)) return false;
	double i123=sgn(iloczyn(p1,p2,p3)),i124=sgn(iloczyn(p1,p2,p4)),i432=sgn(iloczyn(p4,p3,p2)),i431=sgn(iloczyn(p4,p3,p1));
	return (i123!=i124 && i432!=i431) || (i123==0 && i124==0 && i432==0 && i431==0 && !away(p1,p2,p3,p4));
}

pun cross(pun p1, pun p2, pun p3, pun p4){
	if (p1.x==p2.x) return cross(p3,p4,p1,p2);
	double b=((p1.y-p3.y)-(p1.y-p2.y)*(p1.x-p3.x)/(p1.x-p2.x))/((p4.y-p3.y)-(p4.x-p3.x)*(p1.y-p2.y)/(p1.x-p2.x));
	return pun(p3.x+b*(p4.x-p3.x),p3.y+b*(p4.y-p3.y));
}

double odl(pun p1, pun p2){
	return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}

double odl(pun p1, pun p2, pun p3){
	pun p4(p3.x+(p2.y-p1.y)*N,p3.y-(p2.x-p1.x)*N);
	if (intersect(p1,p2,p3,p4)) return odl(p3,cross(p1,p2,p3,p4));
	p4=pun(p3.x-(p2.y-p1.y)*N,p3.y+(p2.x-p1.x)*N);
	if (intersect(p1,p2,p3,p4)) return odl(p3,cross(p1,p2,p3,p4));
	return min(odl(p3,p1),odl(p3,p2));
}

bool intersect(pun p1, pun p2, pun p3, pun p4, double d){
	if (intersect(p1,p2,p3,p4)) return true;
	return min(min(odl(p1,p2,p3),odl(p1,p2,p4)),min(odl(p3,p4,p1),odl(p3,p4,p2)))<d;
}



